package name.panitz.album;
import name.panitz.crempel.util.xml.parslib.*;
import name.panitz.crempel.util.*;
import java.util.*;
import org.w3c.dom.Node;

public class musiccollectionParser extends AbstractParser<musiccollection>{
public ParseResult<musiccollection> parse(List<Node> xs){  return getVmusiccollection().parse(xs);}



  private Parser<Choice_String_author> vChoice_String_author = null;
  public Parser<Choice_String_author> getVChoice_String_author(){
    if (vChoice_String_author==null){
      vChoice_String_author = new PCData().<Choice_String_author>map(new UnaryFunction<String,Choice_String_author>(){
    public Choice_String_author eval(String x){
      return (Choice_String_author)new CChoice_String_authorString(x);
    }
  }).choice(getVauthor().<Choice_String_author>map(new UnaryFunction<author,Choice_String_author>(){
    public Choice_String_author eval(author x){
      return (Choice_String_author)new CChoice_String_authorauthor(x);
    }
  }));
    }
    return vChoice_String_author;
  }

  private Parser<Choice_lp_cd_mc> vChoice_lp_cd_mc = null;
  public Parser<Choice_lp_cd_mc> getVChoice_lp_cd_mc(){
    if (vChoice_lp_cd_mc==null){
      vChoice_lp_cd_mc = getVlp().<Choice_lp_cd_mc>map(new UnaryFunction<lp,Choice_lp_cd_mc>(){
    public Choice_lp_cd_mc eval(lp x){
      return (Choice_lp_cd_mc)new CChoice_lp_cd_mclp(x);
    }
  }).choice(getVcd().<Choice_lp_cd_mc>map(new UnaryFunction<cd,Choice_lp_cd_mc>(){
    public Choice_lp_cd_mc eval(cd x){
      return (Choice_lp_cd_mc)new CChoice_lp_cd_mccd(x);
    }
  })).choice(getVmc().<Choice_lp_cd_mc>map(new UnaryFunction<mc,Choice_lp_cd_mc>(){
    public Choice_lp_cd_mc eval(mc x){
      return (Choice_lp_cd_mc)new CChoice_lp_cd_mcmc(x);
    }
  }));
    }
    return vChoice_lp_cd_mc;
  }

  private Parser<artist> vartist = null;
  public Parser<artist> getVartist(){
    if (vartist==null){
      vartist = new Element<artist>("artist"
     ,new Closure<Parser<artist>>(){public Parser<artist> eval(){return new PCData()
     .<artist>map(new UnaryFunction<String,artist>(){
       public artist eval(String x){
         return new artist(x);
       }
     })
;}}//end of closure
);
    }
    return vartist;
  }

  private Parser<author> vauthor = null;
  public Parser<author> getVauthor(){
    if (vauthor==null){
      vauthor = new Element<author>("author"
     ,new Closure<Parser<author>>(){public Parser<author> eval(){return new PCData()
     .<author>map(new UnaryFunction<String,author>(){
       public author eval(String x){
         return new author(x);
       }
     })
;}}//end of closure
);
    }
    return vauthor;
  }

  private Parser<cd> vcd = null;
  public Parser<cd> getVcd(){
    if (vcd==null){
      vcd = new Element<cd>("cd"
     ,new Closure<Parser<cd>>(){public Parser<cd> eval(){return getVtitle().seq(getVartist()).seq(getVrecordingyear().query()).seq(getVtrack().plus()).seq(getVnote().star()).map(new UnaryFunction<Tuple2<Tuple2<Tuple2<Tuple2<title,artist>,Maybe<recordingyear>>,List<track>>,List<note>>,cd>(){
    public cd eval(Tuple2<Tuple2<Tuple2<Tuple2<title,artist>,Maybe<recordingyear>>,List<track>>,List<note>> p){
      return new cd(p.e1.e1.e1.e1,p.e1.e1.e1.e2,p.e1.e1.e2,p.e1.e2,p.e2);
    }
  })
;}}//end of closure
);
    }
    return vcd;
  }

  private Parser<lp> vlp = null;
  public Parser<lp> getVlp(){
    if (vlp==null){
      vlp = new Element<lp>("lp"
     ,new Closure<Parser<lp>>(){public Parser<lp> eval(){return getVtitle().seq(getVartist()).seq(getVrecordingyear().query()).seq(getVtrack().plus()).seq(getVnote().star()).map(new UnaryFunction<Tuple2<Tuple2<Tuple2<Tuple2<title,artist>,Maybe<recordingyear>>,List<track>>,List<note>>,lp>(){
    public lp eval(Tuple2<Tuple2<Tuple2<Tuple2<title,artist>,Maybe<recordingyear>>,List<track>>,List<note>> p){
      return new lp(p.e1.e1.e1.e1,p.e1.e1.e1.e2,p.e1.e1.e2,p.e1.e2,p.e2);
    }
  })
;}}//end of closure
);
    }
    return vlp;
  }

  private Parser<mc> vmc = null;
  public Parser<mc> getVmc(){
    if (vmc==null){
      vmc = new Element<mc>("mc"
     ,new Closure<Parser<mc>>(){public Parser<mc> eval(){return getVtitle().seq(getVartist()).seq(getVrecordingyear().query()).seq(getVtrack().plus()).seq(getVnote().star()).map(new UnaryFunction<Tuple2<Tuple2<Tuple2<Tuple2<title,artist>,Maybe<recordingyear>>,List<track>>,List<note>>,mc>(){
    public mc eval(Tuple2<Tuple2<Tuple2<Tuple2<title,artist>,Maybe<recordingyear>>,List<track>>,List<note>> p){
      return new mc(p.e1.e1.e1.e1,p.e1.e1.e1.e2,p.e1.e1.e2,p.e1.e2,p.e2);
    }
  })
;}}//end of closure
);
    }
    return vmc;
  }

  private Parser<musiccollection> vmusiccollection = null;
  public Parser<musiccollection> getVmusiccollection(){
    if (vmusiccollection==null){
      vmusiccollection = new Element<musiccollection>("musiccollection"
     ,new Closure<Parser<musiccollection>>(){public Parser<musiccollection> eval(){return getVChoice_lp_cd_mc().star()
     .<musiccollection>map(new UnaryFunction<List<Choice_lp_cd_mc>,musiccollection>(){
       public musiccollection eval(List<Choice_lp_cd_mc> x){
         return new musiccollection(x);
       }
     })
;}}//end of closure
);
    }
    return vmusiccollection;
  }

  private Parser<note> vnote = null;
  public Parser<note> getVnote(){
    if (vnote==null){
      vnote = new Element<note>("note"
     ,new Closure<Parser<note>>(){public Parser<note> eval(){return getVChoice_String_author().star()
     .<note>map(new UnaryFunction<List<Choice_String_author>,note>(){
       public note eval(List<Choice_String_author> x){
         return new note(x);
       }
     })
;}}//end of closure
);
    }
    return vnote;
  }

  private Parser<recordingyear> vrecordingyear = null;
  public Parser<recordingyear> getVrecordingyear(){
    if (vrecordingyear==null){
      vrecordingyear = new Element<recordingyear>("recordingyear"
     ,new Closure<Parser<recordingyear>>(){public Parser<recordingyear> eval(){return new PCData()
     .<recordingyear>map(new UnaryFunction<String,recordingyear>(){
       public recordingyear eval(String x){
         return new recordingyear(x);
       }
     })
;}}//end of closure
);
    }
    return vrecordingyear;
  }

  private Parser<timing> vtiming = null;
  public Parser<timing> getVtiming(){
    if (vtiming==null){
      vtiming = new Element<timing>("timing"
     ,new Closure<Parser<timing>>(){public Parser<timing> eval(){return new PCData()
     .<timing>map(new UnaryFunction<String,timing>(){
       public timing eval(String x){
         return new timing(x);
       }
     })
;}}//end of closure
);
    }
    return vtiming;
  }

  private Parser<title> vtitle = null;
  public Parser<title> getVtitle(){
    if (vtitle==null){
      vtitle = new Element<title>("title"
     ,new Closure<Parser<title>>(){public Parser<title> eval(){return new PCData()
     .<title>map(new UnaryFunction<String,title>(){
       public title eval(String x){
         return new title(x);
       }
     })
;}}//end of closure
);
    }
    return vtitle;
  }

  private Parser<track> vtrack = null;
  public Parser<track> getVtrack(){
    if (vtrack==null){
      vtrack = new Element<track>("track"
     ,new Closure<Parser<track>>(){public Parser<track> eval(){return getVtitle().seq(getVtiming().query()).map(new UnaryFunction<Tuple2<title,Maybe<timing>>,track>(){
    public track eval(Tuple2<title,Maybe<timing>> p){
      return new track(p.e1,p.e2);
    }
  })
;}}//end of closure
);
    }
    return vtrack;
  }}